/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */

#include "EventLib.h"
#include "AboutLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	AboutClose();
}

static Boolean menu(const MenuPickType *pick)
{
	AboutMenu(pick);
}

static void adjustmenu(void)
{
	AboutAdjustMenu();
}

static void memorylow(void)
{
	AboutMemoryLow();
}

const /* EventTableType */ void *AboutEventTable(void)
{
	return(&gEventTable);
}

void AboutEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	gEventTable.objectType.memorylow = memorylow;
	EventTableRegister(&gEventTable);
}
