#pragma once

#include "DialogModalLib.h"

/* Pass this as the iconid parameter to AlertGeneric so that no icon
	will be drawn. */
#define ALERT_NO_ICON			(-1)		/* don't draw an icon */

/* flags for use of Notification Manager when displaying alert in background */
#define ALERT_NOTIFY_NONE		(0)		/* no notification */
#define ALERT_NOTIFY_MARK		(1<<0)	/* mark next to application's name */
#define ALERT_NOTIFY_ICON		(1<<1)	/* icon in Apple menu */
#define ALERT_NOTIFY_SOUND		(1<<2)	/* play sound */
#define ALERT_NOTIFY_ALERT		(1<<3)	/* notification alert */

/* background notification options for Notification Manager */
typedef struct {
	short flags;	/* flags (see values above) */
	short sicn;		/* ID of a 'SICN' resource */
	short sound;	/* ID of a 'snd ' resource, or -1 for system beep */
	short string;	/* ID of a 'STR ' resource */
	short mark;		/* mark flag, either 1 or 0 for an application */
} AlertOptionsType, *AlertOptionsPtr, **AlertOptionsHandle;

void AlertOptionsSet(const AlertOptionsType *options);
Boolean AlertFilter(DialogPtr dlg, EventRecord *event, short *item, void *data);
short AlertCustom(short id, short iconid, DlgModalFilterType filter,
	void *data, short nstrings, ...);
short	AlertStop(short id, CStr255 str);
short	AlertNote(short id, CStr255 str);
short	AlertCaution(short id, CStr255 str);
