#pragma once

#include <stddef.h>
#include "MenuLib.h"

/* structure of an application settings resource */
typedef struct {
	long stack;		/* amount of additional stack space needed */
	long reserve;	/* amount of memory to reserve for critical operations */
	long cushion;	/* amount of memory to keep as a memory cushion */
	long minimum;	/* minimum amount of memory to have available to run */
	short masters;	/* number of master pointer blocks to allocate */
	short version;	/* minimum version of system software */
} ApplicationSettingsType, *ApplicationSettingsPtr, **ApplicationSettingsHandle;

OSType AppCreator(void);
Boolean AppFilesInit(void);
void AppBegin(void);
void AppEnd(void);
void AppRun(void);
void AppFailed(void);
void ApplicationAdjustMenu(void);
Boolean ApplicationMenu(const MenuPickType *pick);
const /* EventTableType */ void *ApplicationEventTable(void);
void ApplicationEventTableRegister(void);
