#include "EventLib.h"
#include "ApplicationPreferencesLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	AppPrefsHide();
}

static void clicked(EventObjectType object, EventObjectType clickedObject,
	EventIDType clickedID)
{
	AppPrefsClicked(object, clickedID);
}

static Boolean menu(const MenuPickType *pick)
{
	return AppPrefsMenu(pick);
}

static void adjustmenu(void)
{
	AppPrefsAdjustMenu();
}

static void memorylow(void)
{
	AppPrefsMemoryLow();
}

const /* EventTableType */ void *AppPrefsEventTable(void)
{
	return(&gEventTable);
}

void AppPrefsEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.focusWindow.clicked = clicked;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	gEventTable.objectType.memorylow = memorylow;
	EventTableRegister(&gEventTable);
}
