/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */
	
#include "EventLib.h"
#include "ClipboardLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	ClipboardHide();
}

static Boolean menu(const MenuPickType *pick)
{
	return(ClipboardMenu(pick));
}

static void adjustmenu(void)
{
	ClipboardAdjustMenu();
}

static void memorylow(void)
{
	ClipboardMemoryLow();
}

static void suspend(void)
{
	ClipboardSuspend();
}

static void resume(void)
{
	ClipboardResume();
}

const /* EventTableType */ void *ClipboardEventTable(void)
{
	return(&gEventTable);
}

void ClipboardEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	gEventTable.objectType.memorylow = memorylow;
	gEventTable.objectType.suspend = suspend;
	gEventTable.objectType.resume = resume;
	EventTableRegister(&gEventTable);
}
