#pragma once

#include "MenuLib.h"
#include "TextScrollLib.h"

typedef struct {
	short					scrapCount;		/* scrap count when clipboard was last updated */
	WindowPtr			window;			/* clipboard's window */
	TaskHandle			task;				/* task for updating clipboard */
	TextScrollHandle	scrl;				/* the text */
} ClipboardType, *ClipboardPtr, **ClipboardHandle;

Boolean ClipboardValid(ClipboardHandle clipboard);
ClipboardHandle ClipboardBegin(void);
void ClipboardEnd(ClipboardHandle clipboard);
void ClipboardRefresh(ClipboardHandle clipboard);
void ClipboardSuspend(void);
void ClipboardResume(void);
void ClipboardShow(void);
void ClipboardHide(void);
void ClipboardAdjustMenu(void);
Boolean ClipboardMenu(const MenuPickType *pick);
void ClipboardMemoryLow(void);
const /* EventTableType */ void *ClipboardEventTable(void);
void ClipboardEventTableRegister(void);
