#pragma once

#include "FrameLib.h"
#include "MenuLib.h"

typedef pascal void (*ListDefinitionType)(short lMessage, Boolean lSelect,
	const Rect *lRect, Cell lCell, short lDataOffset, short lDataLen,
	ListHandle lHandle);

Boolean ListValid(ListHandle list);
WindowPtr ListWindow(ListHandle list);
void *ListData(ListHandle list);
void ListDataSet(ListHandle list, void *data);
FrameHandle ListFrame(ListHandle list);
void ListRect(ListHandle list, Rect *r);
void ListRectAll(ListHandle list, Rect *r);
void ListDataBounds(ListHandle list, Rect *r);
ControlHandle ListVScroll(ListHandle list);
ControlHandle ListHScroll(ListHandle list);

pascal void ListDefinitionDefault(short lMessage, Boolean lSelect,
	const Rect *lRect, Cell lCell, short lDataOffset, short lDataLen,
	ListHandle lHandle);
void ListDefinitionCall(ListHandle list, short lMessage, Boolean lSelect,
	const Rect *lRect, Cell lCell, short lDataOffset, short lDataLen, Handle ldef);
Handle ListDefinition(ListHandle list);
void ListDefinitionSet(ListHandle list, ListDefinitionType defproc);

void ListSelectOne(ListHandle list, Cell select);

Boolean ListSearchInsert(ListHandle list, Ptr buf, short len, Cell *insert);

void ListAdjustMenu(ListHandle list);
Boolean ListMenu(ListHandle list, const MenuPickType *pick);
Boolean ListWithin(ListHandle list, Point where);
void ListKeyDown(ListHandle list, EventRecord *event);
void ListUpdate(ListHandle list);
void ListFocus(ListHandle list, Boolean focus);
void ListActivate(ListHandle list, Boolean active);
void ListGrow(ListHandle list, Rect *size);
void ListZoom(ListHandle list, short *width, short *height);
void ListResize(ListHandle list, short dh, short dv);
void ListMouseDown(ListHandle list, EventRecord *event);

ListHandle ListBegin(const Rect *view, const Rect *bounds, Point size,
	short proc, WindowPtr window, Boolean draw, Boolean grow,
	Boolean horiz, Boolean vert, Boolean frame);
void ListEnd(ListHandle list);

const /* EventTableType */ void *ListEventTable(void);
void ListEventTableRegister(void);
