/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */
	
#include "EventLib.h"
#include "DialogModalLib.h"

static EventTableType gEventTable;
	
static TicksType adjustsleep(EventObjectType object)
{
	return DlgModalAdjustSleep(object);
}

static void update(EventObjectType object)
{
	DlgModalUpdate(object);
}

static void activate(EventObjectType object, Boolean activate)
{
	DlgModalActivate(object, activate);
}

static void prefilter(EventObjectType object, EventRecord *event)
{
	DlgModalFilterPre(object, event);
}

const /* EventTableType */ void *DlgModalEventTable(void)
{
	return(&gEventTable);
}

void DlgModalEventTableRegister(void)
{
	gEventTable.focusWindow.adjustsleep = adjustsleep;
	gEventTable.focusWindow.prefilter = prefilter;
	gEventTable.window.update = update;
	gEventTable.window.activate = activate;
	EventTableRegister(&gEventTable);
}
