#pragma once

#include <stddef.h>

typedef struct {
	size_t elemsz;
	size_t nelem;
	Handle array;
} ArrayListType, *ArrayListPtr, **ArrayListHandle;

Boolean ArrayListValid(ArrayListHandle list);
Boolean ArrayListValidIndex(ArrayListHandle list, size_t index);
ArrayListHandle ArrayListBegin(size_t elemsz);
ArrayListHandle ArrayListEnd(ArrayListHandle list);
size_t ArrayListCount(ArrayListHandle list);
size_t ArrayListItemSize(ArrayListHandle list);
void ArrayListInsert(ArrayListHandle list, size_t index);
void ArrayListDelete(ArrayListHandle list, size_t index);
void ArrayListSet(ArrayListHandle list, size_t index, void *data);
void ArrayListGet(ArrayListHandle list, size_t index, void *data);
void *ArrayListGetHandle(ArrayListHandle list);
void ArrayListDetachHandle(ArrayListHandle list);
void ArrayListAttachHandle(ArrayListHandle list, void *array);

