/* 93/12/05 aih created */

#include "LLLib.h"
#include "MemoryLib.h"

Boolean (LLValid)(LLObject item)
{
	#ifdef LLPTRLIB
		return(MemValid(item));
	#else
		return(HandleValidSize(item, sizeof(LLType)));
	#endif	
}

LLObject (LLNext)(LLObject item)
{
	require(! item || LLValid(item));
	return(item ? next(item) : NULL);
}

LLObject (LLInsert)(LLObject head, LLObject item)
{
	require(! head || LLValid(head));
	require(LLValid(item));
	next(item) = head;
	return(item);
}

LLObject (LLAppend)(LLObject head, LLObject item)
{
	LLObject tail;
	
	if (! head)
		head = item;
	else {
		for (tail = head; next(tail); tail = next(tail))
			;
		next(tail) = item;
	}
	return(head);
}

LLObject (LLDelete)(LLObject head, LLObject item)
{
	require(! head || LLValid(head));
	require(! item || LLValid(item));
	if (head && item) {
		if (head == item)
			head = next(head);
		else {
			LLObject prev = head;
			while (prev && next(prev) != item)
				prev = next(prev);
			check(prev != item);
			if (prev)
				next(prev) = next(item);
		}
	}
	ensure(! head || LLValid(head));
	return(head);
}

LLObject (LLDeleteFast)(LLObject head, LLObject item, LLObject prev)
{
	require(! head || LLValid(head));
	require(! item || LLValid(item));
	if (head && item) {
		if (head == item)
			head = next(head);
		else {
			check(prev != item);
			if (prev)
				next(prev) = next(item);
		}
	}
	ensure(! head || LLValid(head));
	return(head);
}
