#pragma once

#include <stddef.h>
#include "TreeLib.h"

typedef struct LexNodeStruct LexNodeType, *LexNodePtr, **LexNodeHandle;
 
struct LexNodeStruct {
	LexNodePtr left;
	LexNodePtr right;
	LexNodePtr middle;
	Boolean terminal;
	void *data;
	char key;
};

typedef struct {
	LexNodePtr root;
	size_t size;
} LexTreeType, *LexTreePtr, **LexTreeHandle;

typedef void (*LexTreeVisitType)(LexNodePtr node, const char *prefix,
	size_t length, void *data);

Boolean LexTreeValid(LexTreePtr tree);
LexTreePtr LexTreeBegin(void);
void LexTreeEnd(LexTreePtr tree);
LexNodePtr LexTreeRoot(LexTreePtr tree);
size_t LexTreeSize(LexTreePtr tree);
LexNodePtr LexTreeInsert(LexTreePtr t, LexNodePtr p, const char *s, char c);
LexNodePtr LexTreeFind(LexTreePtr t, const char *s);
void LexTreeInOrder(LexNodePtr node, char *prefix, size_t length,
	LexTreeVisitType visit, void *data);
