#include "DocumentLib.h"
#include "EventLib.h"
#include "ResourceConstantsLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	DocClose(object, RLS_ALERT_CLOSING);
}

static Boolean menu(const MenuPickType *pick)
{
	return DocMenu(pick);
}

static void adjustmenu(void)
{
	DocAdjustMenu();
}

static void memorylow(void)
{
	DocMemoryLow();
}

const /* EventTableType */ void *DocEventTable(void)
{
	return(&gEventTable);
}

void DocEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	gEventTable.objectType.memorylow = memorylow;
	EventTableRegister(&gEventTable);
}
