#pragma once

#ifdef MPW
	/* define synonyms for the QuickDraw globals */
	#define thePort		(qd.thePort)
	#define white			(qd.white)
	#define black			(qd.black)
	#define gray			(qd.gray)
	#define ltGray			(qd.ltGray)
	#define dkGray			(qd.dkGray)
	#define arrow			(qd.arrow)
	#define screenBits	(qd.screenBits)
	#define randSeed		(qd.randSeed)
#endif

/* constant specifying the arrow cursor (used by DrawCursor) */
#define arrowCursor (0)

/* describes a port's text drawing settings */
typedef struct {
	short	font;
	Style	face;
	short	mode;
	short	size;
} TextState;

void SetHiliteMode(void);

void InvalXorRgn(RgnHandle rgn1, RgnHandle rgn2);
void InvalXorRect(const Rect *r1, const Rect *r2);

void LocalToGlobalRgn(RgnHandle rgn);
void GlobalToLocalRgn(RgnHandle rgn);
void PortToGlobalRgn(RgnHandle rgn, GrafPtr port);
void GlobalToPortRgn(RgnHandle rgn, GrafPtr port);

void GlobalToPort(Point *pt, GrafPtr port);
void PortToGlobal(Point *pt, GrafPtr port);

void GetTextState(TextState *text);
void SetTextState(const TextState *text);
void TextNormal(void);

void DrawCursor(short id);
void DrawSICN(Handle sicn, Point pt, short index);
void DrawIcon(Handle icon, Point pt);

void BorderRgn(const Rect *content, short width, short margin,
	Boolean visible, RgnHandle rgn);
void BorderDraw(const Rect *content, short width, short margin,
	Boolean visible);

Point DragRgn(RgnHandle dragRgn, RgnHandle frameRgn,
	const RgnHandle deskRgn, const RgnHandle limitRgn,
	const RgnHandle contRgn, const RgnHandle clipRgn,
	GrafPtr port, Point startPt);
Point DragRect(const Rect *dragRect, const Rect *frameRect,
	const RgnHandle contRgn, const RgnHandle clipRgn, Point startPt);
