/*	
	Revision History:
	
	91/04/22 AIH
	- Changed names of a few functions
	
	91/03/06 AIH
	- Added response parameter to functions
	
	91/01/20 AIH
	- Changed the way strings are formatted
	- Added call to ErrorString
	
	91/01/11 AIH
	- Uses sprintf instead of munging the string
	
	91/01/05 Ari Halberstadt (AIH)
	- Inserted this standard header in all files */

#include <string.h>
#include <stdio.h>
#include "AlertLib.h"
#include "ErrorLib.h"

/* Use Notification Manager to display an error message using
	the given string and small icon. See description of
	AlertNotification for more details. */
static error(OSErr err, char *format, short sicnid,
	ProcPtr response, void *data, Boolean init)
{
BEGIN
	char str[512];
	
	/* build error string and post error */
	sprintf(str, format, ErrorString(err), err);
	if (init)
		AlertNotificationINIT(str, sicnid);
	else
		AlertNotification(str, sicnid, response, data);
END
}

/* see description of 'error' */
void ErrorNotification(OSErr err, CStr255 errstr, short sicnid,
	ProcPtr response, void *data)
{
BEGIN
	error(err, errstr, sicnid, response, data, false);
END
}

/* this is the same as ErrorNotification except it can be used by an INIT */
void ErrorNotificationINIT(OSErr err, CStr255 errstr, short sicnid)
{
BEGIN
	error(err, errstr, sicnid, NULL, NULL, true);
END
}
