#pragma once

#include "FileLib.h"

/* information needed for performing buffered IO on a file */
typedef struct {
	FileType *fp;				/* file to read from */
	long position;				/* position in file */
	long index;					/* index to position in buffer */
	long size;					/* size of data in buffer */
	Boolean eof;				/* true if encountered eof */
	char data[FILE_BUFSIZ];	/* data in buffer */
} FileBufferType;

#define FBufEof(buf) ((buf)->eof)

#define FBufReadChar(buf) \
	(buf->index < buf->size ? buf->data[buf->index++] : _FBufReadChar(buf))

void FBufInit(FileBufferType *buf, FileType *fp);
Boolean (FBufEof)(FileBufferType *buf);
void FBufSeek(FileBufferType *buf, size_t pos);
char _FBufReadChar(FileBufferType *buf);
void FBufUnreadChar(FileBufferType *buf);
