#pragma once

#include "LLHandleLib.h"
#include "OffscreenLib.h"
#include "TaskLib.h"

typedef pascal void (*MenuProcPtr)(short msg, MenuHandle menu, Rect *bounds,
	Point hit, short *which);

typedef struct {
	LLType next;					/* next floating menu */

	WindowPtr window;				/* window containing menu */
	MenuHandle menu;				/* handle to menu */
	Boolean owner;					/* true if created menu with GetMenu */
	short item;						/* last item selected from menu */
	
	/* for tearing off the menu */
	Handle mdef;					/* original mdef for menu */
	Point position;				/* position to move window to */
	TaskHandle tearTask;			/* task to position window */

	/* for menu display */
	Handle menuCopy;				/* copy of menu data, for checking if it changed */
	OffscreenHandle offscreen;	/* offscreen bitmap of menu */
} FloatMenuType, *FloatMenuPtr, **FloatMenuHandle;

Boolean FloatMenuValid(FloatMenuHandle fmenu);
FloatMenuHandle FloatMenuBegin(short id);
void FloatMenuEnd(FloatMenuHandle fmenu);
void FloatMenuOpen(FloatMenuHandle fmenu);
void FloatMenuClose(FloatMenuHandle fmenu);
short FloatMenuID(FloatMenuHandle fmenu);
short FloatMenuItem(FloatMenuHandle fmenu);
FloatMenuHandle FloatMenuFindID(short id);
Boolean FloatMenuChanged(FloatMenuHandle fmenu);
void FloatMenuRemember(FloatMenuHandle fmenu);
void FloatMenuForget(FloatMenuHandle fmenu);
void FloatMenuAdjustAll(void);
void FloatMenuAdjust(FloatMenuHandle fmenu);
void FloatMenuDraw(FloatMenuHandle fmenu);
void FloatMenuChoose(FloatMenuHandle fmenu);
void FloatMenuUnhilite(FloatMenuHandle fmenu);
void FloatMenuMemoryLow(void);
const /* EventTableType */ void *FloatMenuEventTable(void);
void FloatMenuEventTableRegister(void);
