#include "EventLib.h"
#include "FrameLib.h"

static EventTableType gEventTable;
	
static Boolean adjustcursor(EventObjectType object, Point where, RgnHandle cursorRgn)
{
	return FrameAdjustCursor(object, where, cursorRgn);
}

static void update(EventObjectType object)
{
	FrameDraw(object);
}

static void grow(EventObjectType object, Rect *size)
{
	FrameGrow(object, size);
}

static void resize(EventObjectType object, short dh, short dv)
{
	FrameResize(object, dh, dv);
}

const /* EventTableType */ void *FrameEventTable(void)
{
	return(&gEventTable);
}

void FrameEventTableRegister(void)
{
	gEventTable.focusWindow.adjustcursor = adjustcursor;
	gEventTable.window.update = update;
	gEventTable.window.grow = grow;
	gEventTable.window.resize = resize;
	EventTableRegister(&gEventTable);
}
