/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */

#include "EventLib.h"
#include "HelpLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	HelpClose();
}

static void idle(EventObjectType object)
{
	HelpIdle(object);
}

static void keydown(EventObjectType object, EventRecord *event)
{
	HelpKeyDown(object, event);
}

static TicksType adjustsleep(EventObjectType object)
{
	return HelpAdjustSleep(object);
}

static void focus(EventObjectType object, Boolean focus)
{
	HelpFocus(object, focus);
}

static Boolean within(EventObjectType object, Point where)
{
	return HelpWithin(object, where);
}

static Boolean mousedown(EventObjectType object, EventRecord *event)
{
	FocusSet(object);
	HelpMouseDown(object, event);
	return(true);
}

static Boolean menu(const MenuPickType *pick)
{
	return HelpMenu(pick);
}

static void adjustmenu(void)
{
	HelpAdjustMenu();
}

static void memorylow(void)
{
	HelpMemoryLow();
}

const /* EventTableType */ void *HelpEventTable(void)
{
	return(&gEventTable);
}

void HelpEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.focusObject.idle = idle;
	gEventTable.focusObject.keydown = keydown;
	gEventTable.focusWindow.adjustsleep = adjustsleep;
	gEventTable.focusWindow.focus = focus;
	gEventTable.focusWindow.within = within;
	gEventTable.focusWindow.mousedown = mousedown;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	gEventTable.objectType.memorylow = memorylow;
	EventTableRegister(&gEventTable);
}
