#pragma once

#include "TextScrollLib.h"

typedef short HelpTopicType;	/* index to a help topic */

typedef struct {
	DialogPtr			dlg;		/* dialog containing the help */
	TextScrollHandle	text;		/* text of current topic */
	ListHandle			list;		/* list of topics */
	HelpTopicType 		topic;	/* index to current topic */
	HelpTopicType		newtopic;/* topic to set on next null event */
} HelpType, **HelpHandle;

Boolean HelpValid(HelpHandle help);
Boolean HelpTopicValid(HelpHandle help, HelpTopicType topic);
HelpHandle HelpBegin(void);
void HelpEnd(HelpHandle help);
HelpTopicType HelpTopic(HelpHandle help);
void HelpTopicSet(HelpHandle help, short topic);
void HelpFocus(HelpHandle help, Boolean focus);
Boolean HelpWithin(HelpHandle help, Point where);
void HelpIdle(HelpHandle help);
void HelpKeyDown(HelpHandle help, EventRecord *event);
void HelpMouseDown(HelpHandle help, EventRecord *event);
Boolean HelpMenu(const MenuPickType *pick);
void HelpAdjustMenu(void);
TicksType HelpAdjustSleep(HelpHandle help);
void HelpOpen(void);
void HelpClose(void);
void HelpMemoryLow(void);
const /* EventTableType */ void *HelpEventTable(void);
void HelpEventTableRegister(void);
