#pragma once

#include <AppleEvents.h>
#include "FileLib.h"

typedef enum {
	HL_FIRST = 0,
	HL_OAPP = 0,	/* open application */
	HL_QUIT,			/* quit application */
	HL_OPEN,			/* open files */
	HL_OPEN_ONE,	/* open one file */
	HL_PRINT,		/* print files */
	HL_PRINT_ONE,	/* print one file */
	HL_LAST
} HighLevelKind;

long AECountFiles(AEDescList *list);
void AEGetNthFile(AEDescList *list, long n, FileType *fp);
void AEGotRequiredParameters(AppleEvent *event);

void HLEventInit(void);
void HLEventInstall(HighLevelKind kind, void (*handler)(...),
	void *data);
void HLEventOpen(AEDescList *list, long n);
void HLEventOpenOne(FileType *fp);
void HLEventPrint(AEDescList *list, long n);
void HLEventPrintOne(FileType *fp);
void HLEventOpenApplication(void);
void HLEventQuit(void);
