#include "EventLib.h"
#include "ListLib.h"
#include "IconListLib.h"

static EventTableType gEventTable;

static void close(EventObjectType object)
{
	IconListEnd(object);
}

static Boolean within(EventObjectType object, Point where)
{
	return IconListWithin(object, where);
}

static Boolean mousedown(EventObjectType object, EventRecord *event)
{
	return IconListMouseDown(object, event);
}

static void grow(EventObjectType object, Rect *size)
{
	IconListGrow(object, size);
}

static void memorylow(void)
{
	IconListMemoryLow();
}

const /* EventTableType */ void *IconListEventTable(void)
{
	return(&gEventTable);
}

void IconListEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.window.grow = grow;
	gEventTable.focusWindow.within = within;
	gEventTable.focusWindow.mousedown = mousedown;
	gEventTable.objectType.memorylow = memorylow;
	EventTableRegister(&gEventTable);
}
