#pragma once

#include "MenuLib.h"

/* types of resources to display in a list */
#define ICON_LIST_ICON			('ICON')
#define ICON_LIST_ICON_LIST	('ICN#')
#define ICON_LIST_SMALL_ICON	('SICN')

/* identifies icon list object in window */
#define ICON_LIST_ID				('ICLS')

typedef struct IconListStruct IconListType, *IconListPtr, **IconListHandle;
typedef void (*IconListActionType)(IconListHandle bar, void *data);

typedef struct IconListStruct {
	OSType type;				/* type of icons displayed in window */
	short iconSize;			/* size of an icon (e.g., 16 or 32 pixels) */
	short cellSize;			/* size of a cell (includes border) */
	Boolean iconMask;			/* true if icon type has a mask in resource */
	WindowPtr window;			/* window to draw list in */
	ListHandle list;			/* the list manager record */
};

Boolean IconListValid(IconListHandle bar);
IconListHandle IconListBegin(OSType type, short id);
void IconListEnd(IconListHandle bar);
Boolean IconListWithin(IconListHandle bar, Point where);
Boolean IconListMouseDown(IconListHandle bar, EventRecord *event);
void IconListGrow(IconListHandle bar, Rect *size);
void IconListMemoryLow(void);
const /* EventTableType */ void *IconListEventTable(void);
void IconListEventTableRegister(void);
