/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */
	
#include "EventLib.h"
#include "MemoryWindowLib.h"

static EventTableType gEventTable;

static Boolean within(EventObjectType object, Point where)
{
	return MemoryWindowWithin(object, where);
}

static Boolean mousedown(EventObjectType object, EventRecord *event)
{
	return MemoryWindowMouseDown(object, event);
}

static void clicked(EventObjectType object, EventObjectType clickedObject,
	EventIDType clickedID)
{
	MemoryWindowClicked(object, clickedID);
}

static void close(EventObjectType object)
{
	MemoryWindowEnd(object);
}

static void update(EventObjectType object)
{
	MemoryWindowUpdate(object);
}

static Boolean menu(const MenuPickType *pick)
{
	return MemoryWindowMenu(pick);
}

static void adjustmenu(void)
{
	MemoryWindowAdjustMenu();
}

const /* EventTableType */ void *MemoryWindowEventTable(void)
{
	return(&gEventTable);
}

void MemoryWindowEventTableRegister(void)
{
	gEventTable.window.close = close;
	gEventTable.window.update = update;
	gEventTable.focusWindow.within = within;
	gEventTable.focusWindow.mousedown = mousedown;
	gEventTable.focusWindow.clicked = clicked;
	gEventTable.objectType.menu = menu;
	gEventTable.objectType.adjustmenu = adjustmenu;
	EventTableRegister(&gEventTable);
}
