#pragma once

#include "MenuLib.h"
#include "OffscreenLib.h"
#include "TaskLib.h"

typedef struct {
	long purgeable;
	long maxcontig;
	long heapused;
	long heapfree;
	long heapsize;
	long stackused;
	long stackfree;
	long stacksize;
} MemoryInfoType;

typedef struct {
	OffscreenHandle offscreen;	/* off screen bit map of memory info */
	MemoryInfoType info;		/* currently displayed memory info */
	Boolean enabled;			/* true if follows memory changes */
} MemoryViewType;

typedef struct {
	DialogPtr dlg;				/* memory dialog */
	TaskHandle task;			/* task for updating views */
	MemoryViewType views[3];	/* views of memory */
	short nviews;				/* number of views */
} MemoryWindowType;

extern MemoryWindowType gMemoryWindow;

void MemoryWindowUpdate(MemoryWindowType *memory);
void MemoryWindowRefresh(MemoryWindowType *memory);
void MemoryWindowBegin(MemoryWindowType *memory);
void MemoryWindowEnd(MemoryWindowType *memory);
Boolean MemoryWindowWithin(MemoryWindowType *memory, Point where);
Boolean MemoryWindowMouseDown(MemoryWindowType *memory, EventRecord *event);
void MemoryWindowClicked(MemoryWindowType *memory, /* EventIDType */ long id);
Boolean MemoryWindowWithin(MemoryWindowType *memory, Point where);
Boolean MemoryWindowMenu(const MenuPickType *pick);
void MemoryWindowAdjustMenu(void);

const /* EventTableType */ void *MemoryWindowEventTable(void);
void MemoryWindowEventTableRegister(void);
