#include "EventLib.h"
#include "RadioLib.h"

static EventTableType gEventTable;
	
static Boolean within(EventObjectType object, Point where)
{
	return(RadioWithin(object, where));
}

static Boolean mousedown(EventObjectType object, EventRecord *event)
{
	return(RadioMouseDown(object, event));
}

static void update(EventObjectType object)
{
	RadioUpdate(object);
}

const /* EventTableType */ void *RadioEventTable(void)
{
	return(&gEventTable);
}

void RadioEventTableRegister(void)
{
	gEventTable.focusWindow.within = within;
	gEventTable.focusWindow.mousedown = mousedown;
	gEventTable.window.update = update;
	EventTableRegister(&gEventTable);
}
