#pragma once

/* an item in the radio button group */
typedef struct {
	ControlHandle ctl;
	short id;
} RadioItemType;

typedef struct {
	WindowPtr window;	/* window containing radio group */
	RadioItemType item;	/* last radio button clicked */
	short nitems;		/* number of radio buttons */
	Rect frame;			/* frame around buttons */
	Rect title;			/* rectangle containing title */
	RgnHandle clipRgn;	/* for setting clip region */
	RgnHandle saveClip;	/* for saving/restoring clip region */
	/* followed by dynamically sized array of radio buttons */
} RadioType, *RadioPtr, **RadioHandle;

Boolean RadioValid(RadioHandle radio);
void RadioEnd(RadioHandle radio);
RadioHandle RadioBegin(WindowPtr window, const Rect *frame, const Rect *title);
void RadioAdd(RadioHandle radio, ControlHandle ctl, short id);
void RadioClick(RadioHandle radio, ControlHandle ctl);
void RadioClickID(RadioHandle radio, short id);
ControlHandle RadioSelected(RadioHandle radio);
short RadioSelectedID(RadioHandle radio);
void RadioUpdate(RadioHandle radio);
Boolean RadioWithin(RadioHandle radio, Point where);
Boolean RadioMouseDown(RadioHandle radio, EventRecord *event);
const /* EventTableType */ void *RadioEventTable(void);
void RadioEventTableRegister(void);
