#pragma once
#include <stddef.h>
#include "FileLib.h"

Boolean ResFileValid(FileType *fp);
Boolean ResValid(Handle rsrc);

Boolean ResFileIsOpen(FileType *fp);
FileRefType ResFileOpen(FileType *fp, FilePermType permission);
void ResFileClose(FileRefType ref);
void ResFileCreate(FileType *fp);
Boolean ResFileExists(FileType *fp);

Boolean ResExists(ResType type, short id);
Boolean ResExists1(ResType type, short id);

Handle ResGet(ResType type, short id);
Handle ResGet1(ResType type, short id);
Handle ResGetIndexed(ResType type, short index);
Handle ResGetIndexed1(ResType type, short index);
Handle ResGetNamed(ResType type, const CStr255 name);
Handle ResGetNamed1(ResType type, const CStr255 name);
Handle ResGetApp(ResType type, short id);
void ResAdd(Handle rsrc, ResType type, short id);
void ResSet(Handle rsrc, ResType type, short id);
void ResRemove(ResType type, short id);
void ResWrite(Handle rsrc);
void ResRelease(Handle rsrc);

void ResPtr(ResType type, short id, void *data, size_t n);
void ResPtrSet(ResType type, short id, void *data, size_t n);

void ResString(short id, CStr255 str);
void ResStringLen(short id, char *str, short len);
void ResStringSet(short id, const CStr255 str);

void ResStr(short id, short n, CStr255 str);
void ResStrLen(short id, short n, char *str, short len);

void ResAttributeSet(Handle rsrc, short attr, Boolean on);

/* useful macros for reading strings */
#define ResStr31(id, n, str)	ResStrLen(id, n, str, sizeof(CStr31))
#define ResStr63(id, n, str)	ResStrLen(id, n, str, sizeof(CStr63))
#define ResString31(id, str)	ResStringLen(id, str, sizeof(CStr31))
#define ResString63(id, str)	ResStringLen(id, str, sizeof(CStr63))
