/* event table functions, called from event library in response to
	events
	
	93/10/18 aih - created */

#include "EventLib.h"
#include "ScrollBarLib.h"

static EventTableType gEventTable;
	
static Boolean within(EventObjectType object, Point where)
{
	return(SBarWithin(object, where));
}

static Boolean mousedown(EventObjectType object, EventRecord *event)
{
	SBarMouseDown(object, event);
	return(true);
}

static void update(EventObjectType object)
{
	SBarUpdate(object);
}

static void activate(EventObjectType object, Boolean activate)
{
	SBarActivate(object, activate);
}

static void resize(EventObjectType object, short dh, short dv)
{
	SBarResize(object, dh, dv);
}

const /* EventTableType */ void *SBarEventTable(void)
{
	return(&gEventTable);
}

void SBarEventTableRegister(void)
{
	gEventTable.focusWindow.within = within;
	gEventTable.focusWindow.mousedown = mousedown;
	gEventTable.window.update = update;
	gEventTable.window.activate = activate;
	gEventTable.window.resize = resize;
	EventTableRegister(&gEventTable);
}
