#pragma once

#include "FrameLib.h"

#define SBAR_MIN_LENGTH	(48)	/* minimum length of a scroll bar */
#define SBAR_WIDTH		(16)	/* width of a scroll bar */

typedef struct {
	FrameHandle	frame;
	long val;
	long maxval;
	ControlHandle ctl;
	WindowPtr window;
	void *data;
	void (*action)(void *data, short part);
	void (*thumb)(void *data, long delta);
} ScrollBarType, **ScrollBarHandle;

short SBarMinWidth(Boolean horizontal, Boolean vertical);
short SBarMinHeight(Boolean horizontal, Boolean vertical);
Boolean SBarValid(ScrollBarHandle sbar);
ScrollBarHandle SBarBegin(WindowPtr window, const Rect *bounds, FrameHandle frame);
void SBarEnd(ScrollBarHandle sbar);
ControlHandle SBarCtl(ScrollBarHandle sbar);
long SBarVal(ScrollBarHandle sbar);
void SBarValSet(ScrollBarHandle sbar, long val);
long SBarMax(ScrollBarHandle sbar);
void SBarMaxSet(ScrollBarHandle sbar, long maxval);
void SBarDataSet(ScrollBarHandle sbar, void *data);
void SBarActionSet(ScrollBarHandle sbar, void (*action)(void *data, short part));
void SBarThumbSet(ScrollBarHandle sbar, void (*thumb)(void *data, long delta));
Boolean SBarIsHorizontal(ScrollBarHandle sbar);
Boolean SBarIsVertical(ScrollBarHandle sbar);
void SBarResize(ScrollBarHandle sbar, short dh, short dv);
void SBarActivate(ScrollBarHandle sbar, Boolean activate);
void SBarUpdate(ScrollBarHandle sbar);
Boolean SBarWithin(ScrollBarHandle sbar, Point where);
void SBarClick(ScrollBarHandle sbar, Point where);
void SBarMouseDown(ScrollBarHandle sbar, EventRecord *event);
const /* EventTableType */ void *SBarEventTable(void);
void SBarEventTableRegister(void);
