#pragma once

#include "LongRectangleLib.h"
#include "TimeLib.h"

#define TE_MAX_LENGTH				(32000)	/* maximum number of characters */
#define TE_MAX_LINES					(16000)	/* maximum number of lines */

#define TESelStart(te)				((**(te)).selStart)
#define TESelStartSet(start, te) ((void) ((**(te)).selStart = (start)))
#define TESelEnd(te)					((**(te)).selEnd)
#define TESelEndSet(end, te) 		((void) ((**(te)).selEnd = (end)))
#define TELength(te)					((**(te)).teLength)
#define TELines(te)					((**(te)).nLines)
#define TELineStart(line, te)		((**(te)).lineStarts[(line)])
#define TELineEnd(line, te)		((**(te)).nLines == 0 ? 0 : (**(te)).lineStarts[(line) + 1])
#define TEView(view, te)			((void) (*(view) = (**(te)).viewRect))
#define TEViewSet(view, te)		((void) ((**(te)).viewRect = *(view)))
#define TEText(te)					((**(te)).hText)
#define TEPort(te)					((**(te)).inPort)
#define TEPortSet(port, te)		((void) ((**(te)).inPort = (port)))
#define TEActive(te)					((**(te)).active != 0)
#define TEWrap(te)					((**(te)).crOnly >= 0)
#define TEWrapSet(wrap, te)		((void) ((**(te)).crOnly = ((wrap) ? 1 : -1)))
#define TEJust(te)					((**(te)).just)

/* rectangles */
void TEDest(LRectType *dest, TEHandle te);
void TEDestSet(const LRectType *dest, TEHandle te);

/* style */
void TEStyleContinuous(short *modes, TextStyle *style, TEHandle te);
void TEStyleOffset(short offset, TextStyle *style, short *height,
	short *ascent, TEHandle te);
void TEStyle(TextStyle *style, short *height, short *ascent, TEHandle te);
void TEStyleSet(short mode, const TextStyle *style, Boolean redraw, TEHandle te);
StScrpHandle TEStyleScrap(TEHandle te);
void TEStyleScrapSet(StScrpHandle scrp, Boolean redraw, TEHandle te);

/* width */
short TEWidthTimeout(short start, short end,
	TicksType timeout, short *final, TEHandle te);
short TEWidth(short start, short end, TEHandle te);

/* edit */
void TEDoCut(TEHandle te);
void TEDoCopy(TEHandle te);
void TEDoPaste(TEHandle te);
void TEDoSetText(const void *text, long length, TEHandle te);
void TEDoInsert(const void *text, long length, StScrpHandle style, TEHandle te);

/* miscelaneous */
void TEReplaceText(Handle text, TEHandle te);
void TEDoActivate(Boolean active, TEHandle te);
